use std::fs::File;
use std::io::{Read, Write};
use std::env::temp_dir;
use std::path::Path;
use serde_json::{Result, Value};

use suppaftp::{FtpError, NativeTlsConnector, NativeTlsFtpStream};
use suppaftp::native_tls::{Certificate, TlsConnector};

mod ftp;

fn main() {
    println!("test");
    let ftp_stream = NativeTlsFtpStream::connect("gitea.piwalker.net:21").unwrap_or_else(|err|
        panic!("{}", err)
    );
    let cert = include_bytes!("../res/vsftpd.crt");
    let cert = Certificate::from_pem(cert).unwrap();
    let mut ftp_stream = ftp_stream.into_secure(NativeTlsConnector::from(TlsConnector::builder().add_root_certificate(cert).build().unwrap()), "gitea.piwalker.net").unwrap();
    assert!(ftp_stream.login("anonymous", "anonymous@").is_ok());
    assert!(ftp_stream.size("test").is_ok());
    println!("test");
    let data = ftp_stream.retr_as_buffer("fcs7/versions.json").unwrap();
    println!("test");
    let v: Value = serde_json::from_reader(data).unwrap();
    println!("fcs7/{}",v[0]["File"].as_str().unwrap());
    let mut data = ftp_stream.retr_as_buffer(format!("fcs7/{}",v[v.as_array().unwrap().len()-1]["File"].as_str().unwrap()).as_str()).unwrap_or_else(|err| panic!("Unable to download file"));
    println!("{}", temp_dir().join("pack.mrpack").display());
    let mut file = File::create(temp_dir().join("pack.mrpack")).unwrap();
    std::io::copy(&mut data, &mut file).unwrap();
    println!("{}",temp_dir().display());

    

    assert!(ftp_stream.quit().is_ok());

}
